; DO 433 amaro 7 2023.asm
; Created: 14.07.2023 18:12:59
; Author : HP
;                ----------- 
;               | ATmega48  |
;               |           |
;               |        PD7|
;               |   PWM1 PD6|-----------------------NEPOUZITO TL D
;               |   PWM2 PD5|INPUT TLACITKA C
;               |           |
;               |        PD4|
;               |        PD3|
;               |        PD2|    
;               |     TX PD1|OUTPUT TEXT 2
;               |     RX PD0|OUTPUT TEXT 1
;               |           |
;               |        PB0|
;               |        PB1|OUTPUT TEXT 3
;               |        PB2|OUTPUT TEXT 4
;               |           |
;               |    SPI PB5|
;               |    SPI PB3|OUTPUT RELE A
;               |    SPI PB4|
;               |     X1 PB6|INPUT TLACITKA A
;               |     X2 PB7|INPUT TLACITKA B
;               |           |
;               |   PC0 ADC0|
;               |   PC1 ADC1|OUTOUT RELE B
;               |   PC2 ADC2|
;               |   PC3 ADC3|
;               |   PC4 ADC4|
;               |   PC5 ADC5|
;                ----------- 
; ============================================
	.DEF POMOC_REG = R16 
	.DEF ADR_REG = R17 		;ADRESY PAMĚTI EEPROM 
	.DEF DATA_REG = R18 	;DATA PRO EEPROM 
	.DEF CITAC1 = R19		;CITAC 1
; ============================================
;       S R A M   D E F I N I T I O N S
; ============================================
.DSEG
.ORG  0X0100
; ============================================
;   R E S E T   A N D   I N T   V E C T O R S
; ============================================
.CSEG
.ORG $0000
H100:
	SBIC PINB,7;Pesko, kdy INPUT TLACITKA B  Pesko, kdy bit v I/O reg. je 0 
	RCALL TEXT_1
	SBIC PINB,6;Pesko, kdy INPUT TLACITKA A  Pesko, kdy bit v I/O reg. je 0 
	RCALL TEXT_2
	SBIC PIND,5	;Pesko, kdy INPUT TLACITKA C  Pesko, kdy bit v I/O reg. je 0 
	RCALL TEXT_3
	SBIC PIND,5	;Pesko, kdy INPUT TLACITKA D  Pesko, kdy bit v I/O reg. je 0 
	RCALL TEXT_3
	RJMP H100
;----------------------------------------------------
TEXT_1:			
SBI PORTD,0 
RCALL T8S
CBI PORTD,0
RET
;---------------------------------------------------
TEXT_2:		
SBI PORTD,1 
RCALL T8S
CBI PORTD,1
RET
;--------------------------------------------------
TEXT_3:		
SBI PORTB,1 
RCALL T8S
CBI PORTB,1
RET
;--------------------------------
TEXT_4:			
SBI PORTB,2 
RCALL T8S
CBI PORTB,2
;RELE_A_B_OFF:
CBI PORTB,3;RELE A OFF
CBI PORTC,1;RELE B OFF
RET
;------------------PODPROGRAMY CASOVANI  -------------------------
T10MIKRO:			
		LDI R27,0
T1001:	INC R27
		CPI R27,10		;6
		BRNE T1001
		RET
T1ms:				
		LDI R28,0	
T1ms1:	rcall T10MIKRO
		INC R28
		CPI R28,22
		BRNE T1ms1
		RET
T10MS:				
		LDI R29,0
T10MS1:	RCALL T1MS 			
		INC R29 
		CPI R29,10
		BRNE T10MS1
		RET
T100MS:
		LDI R30,0

T100MS1:	RCALL T10MS 			
		INC R30 
		CPI R30,10
		BRNE T100MS1
		RET
T300MS:			;KALOBROVANO NA KRYSTAL 20MHz
		LDI R30,0

T100MS3:	RCALL T10MS 			
		INC R30 
		CPI R30,30
		BRNE T100MS3
		RET

T1S:			;KALOBROVANO NA KRYSTAL 20MHz
		LDI R31,0

T1S1:		RCALL T100MS 			
		INC R31 
		CPI R31,10
		BRNE T1S1
		RET
T8S:			;KALOBROVANO NA KRYSTAL 20MHz
		LDI R31,0

T10S1:		RCALL T100MS 			
		INC R31 
		CPI R31,66
		BRNE T10S1
		RET


